---
title: Range.compareBoundaryPoints()
slug: Web/API/Range/compareBoundaryPoints
tags:
  - API
  - DOM
  - Method
  - Range
---
<p>{{ApiRef("DOM")}}</p>

<p><span class="seoSummary">The <strong><code>Range.compareBoundaryPoints()</code></strong> method compares the boundary points of the {{domxref("Range")}} with those of another range.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>compare</em> = <em>range</em>.compareBoundaryPoints(<em>how</em>,<em> sourceRange</em>);
</pre>

<h3 id="Return_value">Return value</h3>

<dl>
 <dt><code>compare</code></dt>
 <dd>A number, <code>-1</code>, <code>0</code>, or <code>1</code>, indicating whether the corresponding boundary-point of the {{domxref("Range")}} is respectively before, equal to, or after the corresponding boundary-point of <em>sourceRange</em>.</dd>
</dl>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>how</code></dt>
 <dd>A constant describing the comparison method:
 <ul>
  <li><code>Range.END_TO_END</code> compares the end boundary-point of <em>sourceRange</em> to the end boundary-point of <code>Range</code>.</li>
  <li><code>Range.END_TO_START</code> compares the end boundary-point of <em>sourceRange</em> to the start boundary-point of <code>Range</code>.</li>
  <li><code>Range.START_TO_END</code> compares the start boundary-point of <em>sourceRange</em> to the end boundary-point of <code>Range</code>.</li>
  <li><code>Range.START_TO_START</code> compares the start boundary-point of <em>sourceRange</em> to the start boundary-point of <code>Range</code>.</li>
 </ul>

 <p>If the value of the parameter is invalid, a {{domxref("DOMException")}} with a <code>NotSupportedError</code> code is thrown.</p>
 </dd>
 <dt><code>sourceRange</code><em> </em></dt>
 <dd>A {{domxref("Range")}} to compare boundary points with the range.</dd>
</dl>

<h2 id="Example">Example</h2>

<pre class="brush: js">var range, sourceRange, compare;
range = document.createRange();
range.selectNode(document.getElementsByTagName("div")[0]);
sourceRange = document.createRange();
sourceRange.selectNode(document.getElementsByTagName("div")[1]);
compare = range.compareBoundaryPoints(Range.START_TO_END, sourceRange);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#dom-range-compareboundarypoints', 'Range.compareBoundaryPoints()')}}</td>
   <td>{{Spec2('DOM WHATWG')}}</td>
   <td>No change.</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM2 Traversal_Range', 'ranges.html#Level2-Range-method-compareBoundaryPoints', 'Range.compareBoundaryPoints()')}}</td>
   <td>{{Spec2('DOM2 Traversal_Range')}}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Range.compareBoundaryPoints")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/DOM/DOM_Reference">The DOM interfaces index</a></li>
</ul>
